Summary: Generic linux kernel
Name: kernel
Version: 2.0.18
Release: 5
Copyright: GPL
Group: Base/Kernel
ExcludeArch: sparc
ExclusiveOS: Linux
Source: pcmcia-cs-2.8.22.tar.gz
Source1: ftp.funet.fi:/pub/Linux/PEOPLE/Linus/v2.0/linux-2.0.18.tar.gz
Source2: kernel-config.i386
Source3: pcmcia-cs-2.8.8-network.script
Source4: ftp://gear.torque.net/pub/bpcd.c
Source5: module-info
Source6: kernel-config.axp
Patch: kernel-make.patch
Patch1: pcmcia-cs-2.8.18-config.patch
Patch2: ftp://ftp.azstarnet.com/pub/linux/axp/sys/axp-diffs-2.0.18.gz
BuildRoot: /tmp/kernel
Provides: module-info
Autoreqprov: no

%package source
Requires: kernel-headers = 2.0.18
Summary: Kernel source tree
Group: Base/Kernel

%package modules
Summary: Collection of kernel modules
Group: Base/Kernel
%ifarch i386
Requires: kernel = 2.0.18
%endif

%package -n pcmcia-cs
Requires: kernel = 2.0.18
Summary: Daemon and device drivers for using PCMCIA adapters
Group: Daemons
Version: 2.8.22

%package headers
Summary: Header files for the Linux kernel.
Group: Base/Kernel

%description
This package contains the Linux kernel that is used to boot and run
your system. It contains few device drivers for specific hardware.
Most hardware is instead supported by modules loaded after booting.

%description source
This is the source code for the Linux kernel. It is required to build
most C programs as they depend on constants defined in here. You can
also build a custom kernel that is better tuned to your particular
hardware.

%description modules
This package includes the modules which provide the support for most
supported hardware devices.  The modules are loaded into the running
kernel after it is booted.

%description -n pcmcia-cs
Many laptop machines (and some others) support PCMCIA cards for expansion. 
Also known as "credit card adapters", PCMCIA cards are small cards for
everything from SCSI support to modems. They are hot swappable (they can
be exchanged without rebooting the system) and quite convienent. This package
contains support for numerous PCMCIA cards of all varieties and supplies a
daemon which allows them to be hot swapped.

%description headers
These are the C header files for the Linux kernel, which define structures
and constants that are needed when building most standard programs under
Linux, as well as to rebuild the kernel.

%prep
rm -rf $RPM_BUILD_ROOT
mkdir $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr/src/
cd $RPM_BUILD_ROOT/usr/src
zcat $RPM_SOURCE_DIR/linux-2.0.18.tar.gz | tar -xvf-

find linux -name "*.orig" -print | xargs rm -f
mv linux linux-2.0.18
ln -sf linux-2.0.18 linux

cd linux-2.0.18

%patch0 -p1
%ifarch axp
%patch2 -p1
%endif

%ifarch i386
cp $RPM_SOURCE_DIR/kernel-config.i386 arch/i386/defconfig
%endif
%ifarch axp
cp $RPM_SOURCE_DIR/kernel-config.axp arch/alpha/defconfig
%endif

# now setup pcmcia stuff back in the build directory
cd $RPM_BUILD_DIR
rm -rf kernel-2.0.18
mkdir kernel-2.0.18
cd kernel-2.0.18
tar xvzf $RPM_SOURCE_DIR/pcmcia-cs-2.8.22.tar.gz
cd pcmcia-cs-2.8.22
%patch1 -p1
touch .prereq.ok
ln -s $RPM_BUILD_ROOT/usr/src/linux-2.0.18 ./kernel-source
ln -s $RPM_BUILD_ROOT ./install-dir

for n in cardmgr debug-tools doc etc flash man modules; do
	cd $n
	ln -s ../kernel-source .
	ln -s ../install-dir .
	cd ..
done

cd ..
mkdir bpcd
cp $RPM_SOURCE_DIR/bpcd.c bpcd

%build
cd $RPM_BUILD_ROOT/usr/src/linux-2.0.18
make oldconfig
make symlinks
make include/linux/version.h

%ifarch i386
# we don't actually build a kernel package on the Alpha
rm -f /usr/include/linux 
ln -sf $RPM_BUILD_ROOT/usr/src/linux/include/linux /usr/include/linux
rm -f /usr/include/asm
ln -sf $RPM_BUILD_ROOT/usr/src/linux/include/asm /usr/include/asm
rm -f /usr/include/scsi
ln -sf $RPM_BUILD_ROOT/usr/src/linux/include/scsi /usr/include/scsi

make boot
make modules

rm -f /usr/include/linux 
ln -sf ../src/linux/include/linux /usr/include/linux
rm -f /usr/include/asm
ln -sf ../src/linux/include/asm /usr/include/asm
rm -f /usr/include/scsi
ln -sf ../src/linux/include/scsi /usr/include/scsi

cd $RPM_BUILD_DIR/kernel-2.0.18/pcmcia-cs-2.8.22
make all

# now for the backpack CD driver
cd $RPM_BUILD_DIR/kernel-2.0.18/bpcd
cc -I$RPM_BUILD_ROOT/usr/src/linux/include -D__KERNEL__ -DMODULE -O2 -c bpcd.c
%endif

%install
cd $RPM_BUILD_ROOT/usr/src/linux-2.0.18
mkdir $RPM_BUILD_ROOT/boot
cp $RPM_SOURCE_DIR/module-info $RPM_BUILD_ROOT/boot/module-info

%ifarch i386
cp System.map $RPM_BUILD_ROOT/boot
cp arch/i386/boot/zImage $RPM_BUILD_ROOT/boot/vmlinuz-2.0.18
ln -sf vmlinuz-2.0.18 $RPM_BUILD_ROOT/boot/vmlinuz
%endif

mkdir -p $RPM_BUILD_ROOT/lib/modules
make PREFIX=$RPM_BUILD_ROOT modules_install
#cp $RPM_BUILD_DIR/kernel-2.0.18/bpcd/bpcd.o $RPM_BUILD_ROOT/lib/modules/2.0.18/cdrom

cd $RPM_BUILD_ROOT/usr/src/linux-2.0.18

# keep kernel-source archive clean
make mrproper
make oldconfig
make symlinks
make include/linux/version.h

%ifarch i386
cd $RPM_BUILD_DIR/kernel-2.0.18/pcmcia-cs-2.8.22
make install

# Install our own network up/down script
install -m755 $RPM_SOURCE_DIR/pcmcia-cs-2.8.8-network.script \
        $RPM_BUILD_ROOT/etc/pcmcia/network

mkdir -p $RPM_BUILD_ROOT/etc/sysconfig

# We need our own default /etc/sysconfig/pcmcia
echo PCMCIA=no > $RPM_BUILD_ROOT/etc/sysconfig/pcmcia
echo PCIC= >> $RPM_BUILD_ROOT/etc/sysconfig/pcmcia 
echo PCIC_OPTS= >> $RPM_BUILD_ROOT/etc/sysconfig/pcmcia
echo CORE_OPTS= >> $RPM_BUILD_ROOT/etc/sysconfig/pcmcia

mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc0.d
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc2.d
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc3.d
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc5.d
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc6.d
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d

# We use different default sequence numbers
ln -sf ../init.d/pcmcia $RPM_BUILD_ROOT/etc/rc.d/rc0.d/K52pcmcia
ln -sf ../init.d/pcmcia $RPM_BUILD_ROOT/etc/rc.d/rc2.d/S45pcmcia
ln -sf ../init.d/pcmcia $RPM_BUILD_ROOT/etc/rc.d/rc3.d/S45pcmcia
ln -sf ../init.d/pcmcia $RPM_BUILD_ROOT/etc/rc.d/rc5.d/S45pcmcia
ln -sf ../init.d/pcmcia $RPM_BUILD_ROOT/etc/rc.d/rc6.d/K52pcmcia

# Finally strip some binaries
cd $RPM_BUILD_ROOT/sbin
strip cardmgr cardctl probe scsi_info ftl_format ftl_check
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
cd /boot
ln -sf vmlinuz-2.0.18 vmlinuz

%post headers
cd /usr/src
ln -sf linux-2.0.18 linux

%preun modules
if [ `uname -r` = "2.0.18" ]; then 
	echo "You cannot remove the kernel-modules package for the currently "
	echo "running kernel".
	exit 1
fi

%ifnarch axp
%files
/boot/vmlinuz-*
/boot/System.map
/boot/module-info
%endif

%files source
%dir /usr/src/linux-2.0.18
/usr/src/linux-2.0.18/COPYING
/usr/src/linux-2.0.18/CREDITS
/usr/src/linux-2.0.18/Documentation
/usr/src/linux-2.0.18/MAINTAINERS
/usr/src/linux-2.0.18/Makefile
/usr/src/linux-2.0.18/Makefile.orig
/usr/src/linux-2.0.18/README
/usr/src/linux-2.0.18/Rules.make
/usr/src/linux-2.0.18/arch
/usr/src/linux-2.0.18/drivers
/usr/src/linux-2.0.18/fs
/usr/src/linux-2.0.18/init
/usr/src/linux-2.0.18/ipc
/usr/src/linux-2.0.18/kernel
/usr/src/linux-2.0.18/lib
/usr/src/linux-2.0.18/mm
/usr/src/linux-2.0.18/modules
/usr/src/linux-2.0.18/net
/usr/src/linux-2.0.18/scripts

%files modules
%ifarch i386
%dir /lib/modules
%dir /lib/modules/2.0.18
/lib/modules/2.0.18/scsi
/lib/modules/2.0.18/net
/lib/modules/2.0.18/block
/lib/modules/2.0.18/cdrom
/lib/modules/2.0.18/fs
/lib/modules/2.0.18/misc
/lib/modules/2.0.18/ipv4
%else
/lib/modules
%endif

%ifarch i386
%files -n pcmcia-cs
%doc kernel-2.0.18/pcmcia-cs-2.8.22/doc/PCMCIA-HOWTO 
%doc kernel-2.0.18/pcmcia-cs-2.8.22/SUPPORTED.CARDS 
%doc kernel-2.0.18/pcmcia-cs-2.8.22/CHANGES 
%doc kernel-2.0.18/pcmcia-cs-2.8.22/COPYING 
%doc kernel-2.0.18/pcmcia-cs-2.8.22/README
/lib/modules/2.0.18/pcmcia

/sbin/cardmgr
/sbin/cardctl
/sbin/probe
/sbin/scsi_info

/sbin/ftl_format
/sbin/ftl_check

/usr/man/man1/cardinfo.1

/usr/man/man8/cardmgr.8
/usr/man/man8/cardctl.8
/usr/man/man8/ftl_format.8
/usr/man/man8/ftl_check.8
/usr/man/man8/scsi_info.8

/usr/man/man5/pcmcia.5
/usr/man/man5/stab.5

/usr/man/man4/pcmcia_core.4
/usr/man/man4/tcic.4
/usr/man/man4/i82365.4
/usr/man/man4/tc589_cs.4
/usr/man/man4/pcnet_cs.4
/usr/man/man4/serial_cs.4
/usr/man/man4/pcmem_cs.4
/usr/man/man4/ftl_cs.4
/usr/man/man4/memory_cs.4

/etc/rc.d/rc0.d/K52pcmcia
/etc/rc.d/rc2.d/S45pcmcia
/etc/rc.d/rc3.d/S45pcmcia
/etc/rc.d/rc5.d/S45pcmcia
/etc/rc.d/rc6.d/K52pcmcia

%config /etc/rc.d/init.d/pcmcia
%config /etc/sysconfig/pcmcia
%dir /etc/pcmcia
/etc/pcmcia/config
/etc/pcmcia/fixed
/etc/pcmcia/ftl
/etc/pcmcia/memory
/etc/pcmcia/network
/etc/pcmcia/pcmem
/etc/pcmcia/scsi
/etc/pcmcia/serial

%config /etc/pcmcia/config.opts
%config /etc/pcmcia/fixed.opts
%config /etc/pcmcia/ftl.opts
%config /etc/pcmcia/memory.opts
%config /etc/pcmcia/pcmem.opts
%config /etc/pcmcia/scsi.opts
%config /etc/pcmcia/serial.opts
%endif

%files headers
/usr/src/linux-2.0.18/include
